;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;Gibt eine Linie aus
;-------------------------------------------------
;%include "./INC/LINIE.inc"
;%include "./INC/linie.inc"
;%include "./INC/outnc-2.7.inc"
;%include "./INC/brechner.inc"

;buf			resb	30
;Deltax		dd	0		;Schritte X
;Deltay		dd	0		;Schritte Y
;Deltaz		dd	0		;Schritte Z
;Linex		dd	0		;Aktueller X-Wert der Linie
;Liney		dd	0		;Aktueller Y-Wert der Linie
;Linez		dd	0		;Aktueller Z-Wert der Linie

;Linedev		db	0		;Liniendefiniton
;	a Z Y X
;Bit	3 2 1 0			X	Y	Z
;	x 0 0 0	nach		+	+	+
;	x 0 0 1	nach		-	+	+
;	x 0 1 0	nach		+	-	+
;	x 0 1 1	nach		-	-	+
;	x 1 0 0	nach		+	+	-
;	x 1 0 1	nach		-	+	-
;	x 1 1 0	nach		+	-	-
;	x 1 1 1	nach		-	-	-
;	0 x x x	relativ zur aktuellen Position
;	1 x x x	absolut zum Werkstücknullpunkt
;-------------------------------------------------

LINIE:
section .text

	mov	eax,3					;lese
	mov	ebx,[datnum]			;von
	mov	ecx,buf				;nach
	mov	edx,16				;Anzahl
	int	80h
	cmp	eax,16				;ob Anzahl gelesen
	jz	.a
	call	error1
	jmp	Ende
.a:
	cmp	word[buf+1],0
	jnz	.a1
	jmp	.a8
.a1:
	mov	eax,19				;setze den Dateizeiger
	mov	ebx,[datnum]			;von
	mov	ecx,0					;Anzahl Bytes
	mov	edx,1					;von der aktuellen Position
	int	80h
	cmp	eax,0
	jge	.a2
	call	error1
	jmp	Ende
.a2:
	sub	eax,13				;Position von Deltax
	
	mov	ecx,eax				;Position
	mov	eax,19				;setze den Dateizeiger
	mov	ebx,[schleifdat]			;von
	mov	edx,0					;Dateianfang=0, aktuelle Position=1, vom Ende=2
	int	80h
	cmp	eax,0
	jge	.a3
	call	error1
	jmp	Ende
.a3:
	mov	eax,3					;lese
	mov	ebx,[schleifdat]			;von
	mov	ecx,buf+16				;nach
	mov	edx,12				;Anzahl
	int	80h
	cmp	eax,12				;ob Anzahl gelesen
	jz	.a4
	call	error1
	jmp	Ende
.a4:
	mov	eax,[buf+16]
	cmp	[buf+3],eax
	jnz	.a5
	mov	eax,[buf+20]
	cmp	[buf+7],eax
	jnz	.a5
	mov	eax,[buf+24]
	cmp	[buf+11],eax
	jnz	.a5
	jmp	.a8

.a5:							;Linie und Position wiederherstellen
	mov	eax,[buf+16]
	mov	[Deltax],eax
	mov	edx,eax				;edx laengstes Maß fuer Vergleich
	mov	ebx,Linex				;und in ebx den zugehörigen Zeiger
	mov	ebp,Deltax				;und in ebp den Vergleichszeiger
	
	mov	eax,[buf+20]
	mov	[Deltay],eax
	cmp	edx,eax
	jae	.a6
	mov	edx,eax				;edx laengstes Maß fuer Vergleich
	mov	ebx,Liney				;und in ebx den zugehörigen Zeiger
	mov	ebp,Deltay				;und in ebp den Vergleichszeiger
.a6:
	mov	eax,[buf+24]
	mov	[Deltaz],eax
	cmp	edx,eax
	jae	.a7
	mov	edx,eax				;edx laengstes Maß fuer Vergleich
	mov	ebx,Linez				;und in ebx den zugehörigen Zeiger
	mov	ebp,Deltaz				;und in ebp den Vergleichszeiger
.a7:
	mov	eax,[buf+3]				;atuelle Position wiederherstellen
	mov	[Linex],eax
	mov	eax,[buf+7]
	mov	[Liney],eax
	mov	eax,[buf+11]
	mov	[Linez],eax
	
	mov	al,[buf]
	mov	[Linedev],al
	jmp	.cc
	
.a8:
	mov	dword[Linex],0
	mov	dword[Liney],0
	mov	dword[Linez],0
	mov	al,[buf]
	test	al,00001000b		;ob relativ
	jnz	.ax1				;wenn 1 = absolut
	jmp	.b
.ax1:						;--- absolut ---
	mov	ecx,1000000000	
	sub	ecx,[X]			;ecx = X_ist
	jc	.ax4
						;--- (+) X_ist ---
	test	al,00000001b
	jz	.ax2				;wenn X_soll = (+)
	add	[buf+3],ecx			;(-) X_soll
	jmp	.ay1				;R(-)  (+ -)

.ax2:						;(+) X_soll
	sub	ecx,[buf+3]			;X_ist - X_soll
	jnc	.ax3
	neg	ecx
	mov	[buf+3], ecx
	jmp	.ay1				;R(+)  (+ +)
.ax3:
	mov	[buf+3],ecx
	or	al,00000001b
	jmp	.ay1				;R(-)  (+ +)

.ax4:						;--- (-) X_ist ---
	neg	ecx
	test	al,00000001b
	jnz	.ax5				;wenn R_soll = 1  (-)
	add	[buf+3],ecx			;R == (+)
	jmp	.ay1				;R (+)  (- +)
	
.ax5:						;R == (-)
	sub	ecx,[buf+3]			;X_ist - X_soll
	jnc	.ax6
	neg	ecx
	mov	[buf+3],ecx
	jmp	.ay1				;R (-)  (- -)
.ax6:
	and	al,11111110b
	mov	[buf+3],ecx			;R (+)  (- -)

.ay1:						;--- absolut ---
	mov	ecx,1000000000	
	sub	ecx,[Y]			;ecx = Y_ist
	jc	.ay4
						;--- (+) Y_ist ---
	test	al,00000010b
	jz	.ay2				;wenn R_soll = 0  (+)
	add	[buf+7],ecx			;R_soll (-)
	jmp	.az1				;R(-)  (+ -)
.ay2:
	sub	ecx,[buf+7]			;Y_ist - Y_soll
	jnc	.ay3
	neg	ecx
	mov	[buf+7], ecx
	jmp	.az1				;R(+)  (+ +)
.ay3:
	mov	[buf+7],ecx
	or	al,00000010b
	jmp	.az1				;R(-)  (+ +)

.ay4:						;--- (-) Y_ist ---
	neg	ecx
	test	al,00000010b
	jnz	.ay5				;wenn R_soll = 1  (-)
	add	[buf+7],ecx			;R == (+)
	jmp	.az1				;R (+)  (- +)
	
.ay5:						;R == (-)
	sub	ecx,[buf+7]			;Y_ist - Y_soll
	jnc	.ay6
	neg	ecx
	mov	[buf+7],ecx
	jmp	.az1				;R (-)  (- -)
.ay6:
	and	al,11111101b
	mov	[buf+7],ecx			;R (+)  (- -)

.az1:						;--- absolut ---
	mov	ecx,1000000000	
	sub	ecx,[Z]			;ecx = Z_ist
	jnc	.az4
						;--- (+) Z_ist ---
	neg	ecx
	test	al,00000100b
	jz	.az2				;wenn R_soll = (+)
	add	[buf+11],ecx			;(-) R_soll
	jmp	.b				;R(-)  (+ -)
.az2:
	sub	ecx,[buf+11]			;Z_ist - Z_soll
	jnc	.az3
	neg	ecx
	mov	[buf+11], ecx
	jmp	.b				;R(+)  (+ +)
.az3:
	mov	[buf+11],ecx
	or	al,00000100b
	jmp	.b				;R(-)  (+ +)

.az4:						;--- (-) Z_ist ---
	test	al,00000100b
	jnz	.az5				;wenn R_soll = 1  (-)
	add	[buf+11],ecx			;R == (+)
	jmp	.b				;R (+)  (- +)
	
.az5:						;R == (-)
	sub	ecx,[buf+11]			;Z_ist - Z_soll
	jnc	.az6
	neg	ecx
	mov	[buf+11],ecx
	jmp	.b				;R (-)  (- -)
.az6:
	and	al,11111011b
	mov	[buf+11],ecx			;R (+)  (- -)

.b:						;--- relativ ---
	mov	[Linedev],al
	mov	eax,[buf+3]
	mov	[Deltax],eax
	mov	edx,eax			;edx soll das längste Maß enthalten
	mov	ebx,Linex			;und in ebx den zugehörigen Zeiger
	mov	ebp,Deltax			;und in ebp den vergleichs Zeiger
	
	mov	eax,[buf+7]
	mov	[Deltay],eax
	cmp	edx,eax
	jae	.b1
	mov	edx,eax			;speichere in edx das größere Maß
	mov	ebx,Liney			;und in ebx den zugehörigen Zeiger
	mov	ebp,Deltay			;und in ebp den vergleichs Zeiger
.b1:
	mov	eax,[buf+11]
	mov	[Deltaz],eax
	cmp	edx,eax
	jae	.b2
	mov	edx,eax			;speichere in edx das größere Maß
	mov	ebx,Linez			;und in ebx den zugehörigen Zeiger
	mov	ebp,Deltaz			;und in ebp den vergleichs Zeiger
.b2:
	cmp	edx,0					;ob Linie laenger als 0 ist
	jz	.ende
.cc:
	mov	ecx,0					;b ecx wird in brechner gesetzt
	mov	[statusB],cl				;b statusB zuruecksetzen
	mov	di,[buf+1]				;b Praezision
.c:
	call	brechner				;b setzt Delay
	call	linie
	call	outnc
	cmp	di,0
	jz	.c2
	dec	di
	mov	ax,0					;b
	mov	al,[statusB]				;b kann bis Unterbrechung gebremst werden
	cmp	ax,di					;b Unterbrechung
	jb	.c1					;b
	or	byte[statusB],10000000b	;b bremsen
.c1:							;b
	cmp	di,0
	jz	.d
.c2:
	mov	eax,[ebx]				;b Ende berechnen eax = Line_
	mov	cl,[statusB]				;b neue Stufe in ecx
	add	eax,ecx				;b zum addieren
	cmp	eax,[ebp]				;b kann bis Ende gebremst werden [ebp] = Länge
	jnz	.c3					;b
	or	byte[statusB],10000000b	;b remsen
.c3:							;b
	mov	eax,[ebp]
	cmp	eax,[ebx]
	jnz	.c
	jmp	.ende
.d:
	mov	eax,[Linex]				;Buffer aktualisieren
	mov	[buf+3],eax
	mov	eax,[Liney]
	mov	[buf+7],eax
	mov	eax,[Linez]
	mov	[buf+11],eax

	mov	eax,19				;setze den Dateizeiger
	mov	ebx,[datnum]			;von
	mov	ecx,13				;Anzahl Bytes
	neg	ecx					;niedriger
	mov	edx,1					;von der aktuellen Position
	int	80h
	cmp	eax,0
	jg	.d1
	call	error1
	jmp	Ende
.d1:
	mov	eax,4					;schreibe
	mov	ebx,[datnum]			;nach
	mov	ecx,buf+3				;von
	mov	edx,13				;Anzahl Bytes
	int	80h
	cmp	eax,13				;ob Anzahl geschrieben
	jz	.ende
	call	error1
	jmp	Ende
.ende:
	mov	al,[buf+15]
	ret


