;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;Fuehrt naechsten befehl in schleifen aus, wenn Bedingung zutrifft
;-------------------------------------------------
;%include "./INC/BEDINGUNG.inc"

;section .bss
;buf			resb	25
;-------------------------------------------------

BEDINGUNG:
section .data

.datpos			dd	0
.wert1			dd	0
.naechster			db	1,16,6,6,6,20,24,1,1,4,20,24,9,2,2,5,6,5,0,3,14,5,5,0,0,0,0,0,0,0,0

section .text
	mov	eax,3				;lese
	mov	ebx,[datnum]		;von datei
	mov	ecx,buf			;nach buffer
	mov	edx,10			;anzahl Bytes ein
	int	80h
	cmp	eax,10			;alle Bytes gelesen?
	jz	.a
	call	error1
	jmp	Ende
.a:
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von datei
	mov	ecx,0				;anzahl Bytes ein
	mov	edx,1				;0=vom Anfang, 1=von hier, 2=vom Ende
	int	80h
	mov	[.datpos],eax		;aktuelle Position
	
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von datei
	mov	ecx,[buf+1]			;anzahl Bytes
	mov	edx,0				;0=vom Anfang, 1=von hier, 2=vom Ende
	int	80h
	cmp	eax,[buf+1]
	jz	.a3
	call	error1
	jmp	Ende
.a3:
	mov	eax,3				;lese
	mov	ebx,[datnum]		;von datei
	mov	ecx,.wert1			;nach buffer
	mov	edx,4				;anzahl Bytes
	int	80h
	cmp	eax,4				;alle Bytes gelesen?
	jz	.a4
	call	error1
	jmp	Ende
.a4:
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von datei
	mov	ecx,[.datpos]		;anzahl Bytes
	mov	edx,0				;0=vom Anfang, 1=von hier, 2=vom Ende
	int	80h
	cmp	eax,[.datpos]
	jz	.b
	call	error1
	jmp	Ende
.b:
	mov	al,[buf+9]			;naechster Befehl in al
	mov	dl,[buf]			;Bedingung
	
	cmp	dl,0				;groesser
	jnz	.ba
	mov	edx,[.wert1]
	cmp	edx,[buf+5]
	jbe	.e2
	jmp	.ende
.ba:
	cmp	dl,1				;kleiner
	jnz	.bb
	mov	edx,[.wert1]
	cmp	edx,[buf+5]
	jae	.e2
	jmp	.ende
.bb:
	cmp	dl,2				;gleich
	jnz	.bc
	mov	edx,[.wert1]
	cmp	edx,[buf+5]
	jnz	.e2
	jmp	.ende
.bc:
	cmp	dl,3				;groesser gleich
	jnz	.bd
	mov	edx,[.wert1]
	cmp	edx,[buf+5]
	jb	.e2
	jmp	.ende
.bd:
	cmp	dl,4				;kleiner gleich
	jnz	.be
	mov	edx,[.wert1]
	cmp	edx,[buf+5]
	ja	.e2
	jmp	.ende
.be:
	jmp	Ende

.e2:
	mov	eax,0
	mov	al,[buf+9]			;naechster Befehl
	mov	edi,eax
	cmp	byte[.naechster+edi],0
	jz	.ende
	mov	eax,3				;lese
	mov	edx,0	
	mov	dl,[.naechster+edi]	;anzahl Bytes
	mov	ebx,[datnum]		;von datei
	mov	ecx,buf			;nach buffer
	int	80h
	cmp	al,[.naechster+edi]	;alle Bytes gelesen?
	jz	.e1
	call	error1
	jmp	Ende
.e1:
	mov	ebx,0
	mov	bl,[.naechster+edi]	;Befehlslaenge von buf
	dec	ebx
	mov	al,[buf+ebx]		;letztes Byte -> folgender Befehl
.ende:
	call	stdout
	ret
